package ru.ulstu.target;

import ru.ulstu.datamodel.exception.ModelingException;
import ru.ulstu.datamodel.ts.TimeSeries;
import ru.ulstu.datamodel.ts.TimeSeriesValue;

import java.lang.reflect.InvocationTargetException;
import java.time.LocalDateTime;
import java.util.Map;
import java.util.concurrent.ExecutionException;

public abstract class Target {
    private final String name;

    public Target(String name) {
        this.name = name;
    }

    public String getName() {
        return name;
    }

    public abstract TimeSeries calculate(TimeSeries model) throws ModelingException, ExecutionException, InterruptedException, InvocationTargetException, NoSuchMethodException, InstantiationException, IllegalAccessException;

    public TimeSeries calculate(Map<LocalDateTime, Double> values) throws ModelingException, ExecutionException, InterruptedException, InvocationTargetException, NoSuchMethodException, InstantiationException, IllegalAccessException {
        TimeSeries model = new TimeSeries();
        for (var entry : values.entrySet()) {
            model.addValue(new TimeSeriesValue(entry.getKey(), entry.getValue()));
        }
        return calculate(model);
    }
}
